import java.util.*;

//***************************************************************************

class CalUnknownValueException extends RuntimeException{

//---------------------------------------------------------------------------

  CalUnknownValueException(){
    super();
  }

//---------------------------------------------------------------------------

  CalUnknownValueException( String s ){
    super( s );
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

class CalValue{

//---------------------------------------------------------------------------

  static private Hashtable values;

//---------------------------------------------------------------------------

  static void init(){
    // Create the master hashtable and some basic values
    values = new Hashtable();
    Hashtable t1 = new Hashtable();
    Hashtable t2 = new Hashtable();
    values.put( "DEFAULT", t1 );
    values.put( "GLOBAL", t2 );
    t1.put( "NAME", "DEFAULT" );
    t2.put( "NAME", "GLOBAL" );
  }

//---------------------------------------------------------------------------

  static public synchronized String get( String table, String name )
    throws CalUnknownValueException{

    String ret = null;

    // Create the master hashtable, if necessary
    if( values == null ){
      init();
    }

    try {
      Hashtable t = (Hashtable)values.get( table );
      if( t == null ){
        System.out.println( "throwing null table" );
        throw new CalUnknownValueException( table + "." + name );
      }
      ret = (String)t.get( name );
    } catch( CalUnknownValueException e1 ){
      System.out.println( "Caught e1" );
      try{
        ret = get( "GLOBAL", name );
      } catch( CalUnknownValueException e2 ){
        System.out.println( "Caught e2" );
        ret = get( "DEFAULT", name );
        // The exception here will be thrown
      }
    }

    if( ret == null ){
      System.out.println( "returning null value" );
      throw new CalUnknownValueException( table + "." + name );
    }

    return ret;
  }

//---------------------------------------------------------------------------

  static public synchronized void put( String table,String name,String value ){

    // Create the master hashtable, if necessary
    if( values == null ){
      init();
    }

    // First, get the table or create a new one
    Hashtable t = (Hashtable)values.get( table );
    if( t == null ){
      t = new Hashtable();
      values.put( table, t );
      t.put( "NAME", table );
    }

    // Now put the value there
    t.put( name, value );
  }

//---------------------------------------------------------------------------

  public static void main( String args[] ){

    System.out.println( CalValue.get( "baz", "zzz" ) );
    CalValue.put( "DEFAULT", "aa", "bb" );
    CalValue.put( "GLOBAL", "a", "b" );
    CalValue.put( "foo", "a", "c" );
    System.out.println( CalValue.get( "GLOBAL", "a" ) );
    System.out.println( CalValue.get( "foo", "a" ) );
    System.out.println( CalValue.get( "bar", "a" ) );
    System.out.println( CalValue.get( "bar", "aa" ) );

    CalValue.put( "GLOBAL", "aa", "cc" );
    System.out.println( CalValue.get( "bar", "aa" ) );
  }

//---------------------------------------------------------------------------

}

