import java.awt.*;

//***************************************************************************

abstract class AreYouSureWindow extends Frame{

  Button yes;
  Button no;

//---------------------------------------------------------------------------

  AreYouSureWindow( String name ){
    super( "CaL: " + name + " - Are You Sure?" );
    
    yes = new Button( "Yes" );
    yes.requestFocus();
    no  = new Button( "No" );

    Panel buttonPanel = new Panel();
    buttonPanel.setLayout( new BorderLayout() );
    buttonPanel.add( "West", yes );
    buttonPanel.add( "East", no );

    setLayout( new BorderLayout() );
    add( "South", buttonPanel );
  }

//---------------------------------------------------------------------------

  public boolean handleEvent( Event evt ){

    if( evt.target == yes ){
      yes_action();
      return true;
    } else if( evt.target == no ){
      no_action();
      return true;
    } else if( evt.id == Event.KEY_PRESS ){
      switch( evt.key ){
        //case 'y':
        //case 'Y':
        case '\n':
          yes_action();
          return true;
        //case 'n':
        //case 'N':
        case '\027':    // ESC
          no_action();
          return true;
      }
    }

    return false;
  }

//---------------------------------------------------------------------------

  abstract void yes_action();

//---------------------------------------------------------------------------

  abstract void no_action();

//---------------------------------------------------------------------------

}

//***************************************************************************

class AreYouSureQuitWindow extends AreYouSureWindow{

//---------------------------------------------------------------------------

  AreYouSureQuitWindow(){
    super( "Quit" );
    
    add( "North", new Label( "Are you sure you want to shut down CaL?" ) );
    pack();
    show();

  }

//---------------------------------------------------------------------------

  void yes_action(){
    dispose();

    // Shut down the program
    CalValue.put( "SYSTEM", "status", "shutdown" );
  }

//---------------------------------------------------------------------------

  void no_action(){
    dispose();
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

class AreYouSureDisconnectWindow extends AreYouSureWindow{

  Buffer tonet;
  String command;
  TabTextField blurb;
  Checkbox andQuit;

//---------------------------------------------------------------------------

  AreYouSureDisconnectWindow( Buffer n, String c ){
    super( c );

    tonet = n;
    command = c;

    andQuit = new Checkbox( "Quit CaL when disconnected" );
    andQuit.setState( true );
    andQuit.enable( true );
    
    blurb = new TabTextField( yes );
    Panel blurbPanel = new Panel();
    blurbPanel.setLayout( new BorderLayout() );
    blurbPanel.add( "West", new Label( "Blurb: " ) );
    blurbPanel.add( "Center", blurb );
    blurbPanel.add( "South", andQuit );
    
    add( "North", new Label( "Are you sure you want to " + command + "?" ) );
    add( "Center", blurbPanel );
    pack();
    show();

  }

//---------------------------------------------------------------------------

  void yes_action(){

    String send;
    send = "/" + command;

    String blurbString = blurb.getText();
    if( blurbString.length() != 0 ){
      send = send + " " + blurbString;
    }

    send = send + "\n";

    tonet.put( send );

    if( andQuit.getState() ){
      // The quit box was checked, so shutdown when we disconnect
      CalValue.put( "SYSTEM", "status", "standby" );
    }

    dispose();
  }

//---------------------------------------------------------------------------

  void no_action(){
    dispose();
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

